<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTeknikDetayGrup ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTeknikDetayGrup
 * @subpackage Arrays
 */
class ArrayOfTeknikDetayGrup extends AbstractStructArrayBase
{
    /**
     * The TeknikDetayGrup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TeknikDetayGrup[]
     */
    public $TeknikDetayGrup;
    /**
     * Constructor method for ArrayOfTeknikDetayGrup
     * @uses ArrayOfTeknikDetayGrup::setTeknikDetayGrup()
     * @param \StructType\TeknikDetayGrup[] $teknikDetayGrup
     */
    public function __construct(array $teknikDetayGrup = array())
    {
        $this
            ->setTeknikDetayGrup($teknikDetayGrup);
    }
    /**
     * Get TeknikDetayGrup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TeknikDetayGrup[]|null
     */
    public function getTeknikDetayGrup()
    {
        return isset($this->TeknikDetayGrup) ? $this->TeknikDetayGrup : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTeknikDetayGrup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTeknikDetayGrup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTeknikDetayGrupForArrayConstraintsFromSetTeknikDetayGrup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTeknikDetayGrupTeknikDetayGrupItem) {
            // validation for constraint: itemType
            if (!$arrayOfTeknikDetayGrupTeknikDetayGrupItem instanceof \StructType\TeknikDetayGrup) {
                $invalidValues[] = is_object($arrayOfTeknikDetayGrupTeknikDetayGrupItem) ? get_class($arrayOfTeknikDetayGrupTeknikDetayGrupItem) : sprintf('%s(%s)', gettype($arrayOfTeknikDetayGrupTeknikDetayGrupItem), var_export($arrayOfTeknikDetayGrupTeknikDetayGrupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TeknikDetayGrup property can only contain items of type \StructType\TeknikDetayGrup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TeknikDetayGrup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TeknikDetayGrup[] $teknikDetayGrup
     * @return \ArrayType\ArrayOfTeknikDetayGrup
     */
    public function setTeknikDetayGrup(array $teknikDetayGrup = array())
    {
        // validation for constraint: array
        if ('' !== ($teknikDetayGrupArrayErrorMessage = self::validateTeknikDetayGrupForArrayConstraintsFromSetTeknikDetayGrup($teknikDetayGrup))) {
            throw new \InvalidArgumentException($teknikDetayGrupArrayErrorMessage, __LINE__);
        }
        if (is_null($teknikDetayGrup) || (is_array($teknikDetayGrup) && empty($teknikDetayGrup))) {
            unset($this->TeknikDetayGrup);
        } else {
            $this->TeknikDetayGrup = $teknikDetayGrup;
        }
        return $this;
    }
    /**
     * Add item to TeknikDetayGrup value
     * @throws \InvalidArgumentException
     * @param \StructType\TeknikDetayGrup $item
     * @return \ArrayType\ArrayOfTeknikDetayGrup
     */
    public function addToTeknikDetayGrup(\StructType\TeknikDetayGrup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TeknikDetayGrup) {
            throw new \InvalidArgumentException(sprintf('The TeknikDetayGrup property can only contain items of type \StructType\TeknikDetayGrup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TeknikDetayGrup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TeknikDetayGrup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TeknikDetayGrup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TeknikDetayGrup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TeknikDetayGrup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TeknikDetayGrup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TeknikDetayGrup
     */
    public function getAttributeName()
    {
        return 'TeknikDetayGrup';
    }
}
